
local MainScene = class("MainScene", function()
    return display.newPhysicsScene("MainScene")
end)


local EDGESEGMENTNUMBER = 10

GROUND_TAG   = 1
PLAYER_TAG   = 2


function MainScene:ctor()

	self.world = self:getPhysicsWorld()
    self.world:setGravity(cc.p(0, -400.0))
    self.world:setDebugDrawMask(cc.PhysicsWorld.DEBUGDRAW_ALL)

    self.ground = display.top * 4 / 10
    cc.ui.UILabel.new({
            UILabelType = 2, text = "Hello, World", size = 64})
        :align(display.CENTER, display.cx, display.cy)
        :addTo(self)

        local t = {}

        for i=1,10 do 

            local skeletonNode = display.newSprite("left.png")
            skeletonNode:setTouchEnabled(true)
            skeletonNode:setPosition(math.random(0,960) , 500)
            self:addChild(skeletonNode)

		    local MATERIAL_DEFAULT = cc.PhysicsMaterial(0.0, 0.0, 0.0)
		    local body = cc.PhysicsBody:createBox(skeletonNode:getContentSize(), MATERIAL_DEFAULT, cc.p(0,0))

		    skeletonNode:setPhysicsBody(body)

		    table.insert(t,skeletonNode)
        end
     

        self:addEdgeSegment()


        for k,v in pairs(t) do
        	print(" k "..k)
        	print(" x "..v:getPositionX())
        	print(" y "..v:getPositionY())
        	print(" og "..v:getOpacity())

        	if v:isVisible() then
        		print("v true")
        	else
        		print("v false")
        	end

        end
end

function MainScene:addEdgeSegment()
    local w = 2000
    local h1 = display.top * 8 / 10
    local h2 = self.ground


    local sky = display.newNode()
    local bodyTop = cc.PhysicsBody:createEdgeSegment(cc.p(0, h1-EDGESEGMENTNUMBER), cc.p(w, h1-EDGESEGMENTNUMBER), cc.PhysicsMaterial(0.0, 0.0, 0.0), EDGESEGMENTNUMBER)
    sky:setPhysicsBody(bodyTop)
    self:addChild(sky)
    bodyTop:setCategoryBitmask(0x1000)
    bodyTop:setContactTestBitmask(0x0000)
    bodyTop:setCollisionBitmask(0x0001)


    local ground = display.newNode()
    local bodyBottom = cc.PhysicsBody:createEdgeSegment(cc.p(0, h2-EDGESEGMENTNUMBER), cc.p(w, h2-EDGESEGMENTNUMBER), cc.PhysicsMaterial(0.0, 0.0, 0.0), EDGESEGMENTNUMBER)
    ground:setPhysicsBody(bodyBottom)
    self:addChild(ground)
    bodyBottom:setCategoryBitmask(0x1000)
    bodyBottom:setContactTestBitmask(0x0001)
    bodyBottom:setCollisionBitmask(0x0011)
    ground:setTag(GROUND_TAG)


end

function MainScene:onEnter()
end

function MainScene:onExit()
end

return MainScene
